<?php
/* *** ** * fastIce Framework.
** *
*
	fastIce alpha 0.42 © 2010~2011 noferi Mickaël/m2m - noferov@gmail.com - Some Rights Reserved.

	Except where otherwise noted, this work is licensed under a Creative Commons Attribution 3.0 License, CC-by-nc-sa
	terms of licence CC-by-nc-sa are readable at : http://creativecommons.org/licenses/by-nc-sa/3.0/
*
** *
* ** *** */

/*

changelog for 0.42
	- squeleton and page ini files are now cached in redis.
	- render page specific keywords (title, js, jquery,..) are cached too, so, now js included in a plugin still here, and you can cache your plugin too
		cache of this keywords are done on addToKw or setKw function, the noRenderCache() function is here to not cache this info.

*/

// global config .......................................

define ('template','fr');

define('redisServer','127.0.0.1');
define('redisPrefix','laphrodite');

define('site_url','/redis/');
//define('site_full_url','http://votreIpOuDomaine/redis/');

define('defaultTitle','titre par default');
define('defaultKeywords','mot clef par default');
define('defaultDescription','description par default');
define('defaultMeta','');

setlocale (LC_ALL, 'fr_FR.utf8','fra');
ini_set('display_errors', 1);
set_time_limit(0);

/* ********************* **/

define('includeChar','§');
//define('callbackChar','$');
define('callbackStart','$');
define('callbackEnd','$');
define('includeWordSize','4,2048');
//define('callbackWordSize','4,16');
define ('includePattern','/'.includeChar.'([^'.includeChar.']{'.includeWordSize.'})'.includeChar.'/u');
//define ('callbackPattern','/'.callbackChar.'([^'.callbackChar.']{'.callbackWordSize.'})'.callbackChar.'/u');
define ('noFollowKeyWord','[$$]');

global $nofollow,$nodesigncache,$norendercache,$renderInclude,$redis,$global_current_file,$fnc,$seedPath,$designPath,$commonDesignPath;
$redis = new Redis(); if(!$redis->connect(redisServer)) die('cannot rape the database ...');
/*
function rdOpenSession($path, $name)
{	global $rdSessionKeyName,$rdSessionMaxTime;
	$rdSessionKeyName = 'session:'.$name.':';
	$rdSessionMaxTime = ini_get("session.gc_maxlifetime");
	return true;
}

function rdCloseSession(){ return true; }
function rdGcSession($time){ return true; }

function rdReadSession($id)
{	global $rdSessionKeyName,$redis;
	$data = $redis->get($rdSessionKeyName.$id);
	if($data !== false) return $data; else return '';
}

function rdWriteSession($id,$data)
{	global $rdSessionKeyName,$redis,$rdSessionMaxTime;
	$redis->setex($rdSessionKeyName.$id,$rdSessionMaxTime,$data);
	return true;
}

function rdDestroySession($id)
{	global $rdSessionKeyName,$redis;
	$redis->delete($rdSessionKeyName.$id);
	return true;
}
*/
//if(false === session_set_save_handler("rdOpenSession", "rdCloseSession", "rdReadSession", "rdWriteSession", "rdDestroySession", "rdGcSession")) die('session set.');
//session_start();

if(isset($_GET['deleteCache']))
{	$cache = $redis->keys(redisPrefix.':designCache:*');
	foreach($cache as $c) $redis->delete($c);
}

define ('site_full_path',dirname(__FILE__));
define ('site_path',site_full_path.'/files');
define ('common_path','commun');
define ('module_path','modules');

$nofollow=0;$nodesigncache=0;$norendercache=0;$renderInclude=array();$global_current_file='';$fnc=array();$designPath='';$commonDesignPath='';
/* additionnal keywords for render */
function addToRender($word,$txt) { global $renderInclude; if(!isset($renderInclude[$word])) $renderInclude[$word]=''; $renderInclude[$word] .= $txt; }
function setRender($word,$txt) { global $renderInclude; $renderInclude[$word] = $txt; }
global $renderWords;
$renderWords = array('head','js','jquery','title','meta','style','keywords','description');
foreach($renderWords as $out => $word)
{	eval('function addTo'.ucfirst($word).'($txt){addToRender("'.$word.'",$txt); global $renderInclude; setRenderCache("'.$word.'",$renderInclude["'.$word.'"]); }function set'.ucfirst($word).'($txt){setRender("'.$word.'",$txt); global $renderInclude; setRenderCache("'.$word.'",$renderInclude["'.$word.'"]);}');
	$renderInclude[$word]='';
}

function renderPage($page)
{	global $renderInclude;
	foreach($renderInclude as $word => $value)
	{	$page = str_replace('['.$word.']', $value, $page);
		
	} print $page;
}

function get_include_contents($filename)
{	if(is_file($filename))
	{	//$start = microtime(true);
		ob_start(); include ($filename); $contents = ob_get_contents(); ob_end_clean();
		//print '<br>load '.$filename.' in '.((microtime(true)-$start)*1000);
		return $contents;
	} return false;
}

function showPage($string,$seed=0)
{	global $fnc,$global_current_file,$global_constants,$need_fix_name,$seedPath,$designPath,$commonDesignPath,$redis;
	$start = microtime(true);
	$key = $string[1];
//	print '<br>key : '.$key.' path : '.$designPath;
	if($seed) { $seedPath=$key; $designPath=$key; $commonDesignPath=''; }
	$dpath = $designPath; $cdpath = $commonDesignPath;
//	print '<br>seed : '.$seed.' path : "'.$designPath.'"';
	$out = '';
	if($seed)
	{	// we want a complete page, get his info and skelet from redis or file.
		$page_opt = $redis->hgetall(redisPrefix.':designCache:pages:'.$key);
		if(empty($page_opt)) // redis page info not set
		{	$path = template.'/'.$key.'/'.$key.'.ini';
			if(is_file($path))
			{	$page_opt = parse_ini_file($path);
				//print '<br>load skeleton from file : ';
				//print_r($page_opt);
				//$redis->multi(Redis::PIPELINE);foreach($page_opt as $o)$redis->hset
				$redis->hMset(redisPrefix.':designCache:pages:'.$key,$page_opt);
			}
			//else print '<br> no skeleton!';
		}// else { print '<br>load skeleton from redis : '; print_r($page_opt); }

		if(!isset($page_opt['skeleton'])) $page_opt['skeleton'] = 'normal';
		if(!isset($page_opt['title'])) $page_opt['title'] = defaultTitle;
		if(!isset($page_opt['keywords'])) $page_opt['keywords'] = defaultKeywords;
		if(!isset($page_opt['description'])) $page_opt['description'] = defaultDescription;
		if(!isset($page_opt['meta'])) $page_opt['meta'] = defaultMeta;

		global $renderInclude;
		$renderInclude['title'] = $page_opt['title'];
		$renderInclude['keywords'] = $page_opt['keywords'];
		$renderInclude['description'] = $page_opt['description'];

		$skeleton = $redis->get(redisPrefix.':designCache:'.template.':skeleton:'.$page_opt['skeleton']);
		if($skeleton === false) // skeleton not cached in redis, load it from disk
		{	//print '<br>skeleton not found in redis !';//.redisPrefix.':'.template.':skeleton:'.$page_opt['skeleton'];
			$path = template.'/'.common_path.'/skeleton/'.$page_opt['skeleton'].'.html';
			if(is_file($path))
			{	$out = file_get_contents($path);
				$redis->set(redisPrefix.':designCache:'.template.':skeleton:'.$page_opt['skeleton'],$out);
			} else $out = '§header§<h3>no valid skeleton<br>'.$path.'</h3>§footer§';
		} else $out = $skeleton;

		// loading render keywords cache, if set

		global $renderWords,$renderInclude;
		foreach($renderWords as $w)
		{	$d = getRenderCache($w);
			if($d !== false)// { $fn = 'set'.ucfirst($w); $fn($d); }
				$renderInclude[$w]=$d;
		}

	} else {
		$global_current_file = $key;
		$out = getDesign($key);
		$designPath .= '/'.$key; $commonDesignPath .= '/'.$key;
	}

//	print ' -> <b>'.$designPath.'</b>';

//	$zstart = microtime(true);
	if($out && $out!='') $out = preg_replace_callback(includePattern,'showPage',$out); else $out = '';
//	print '<br>callback of '.$key.' done in '.((microtime(true)-$zstart)*1000);

	if($seed && $need_fix_name) $out = str_replace(noFollowKeyWord, includeChar, $out);
	$designPath = $dpath; $commonDesignPath = $cdpath;

//	print '<br>page '.$key.' show in '.((microtime(true)-$start)*1000);
	return $out;
}

function getArgs($string,$word,$separator)
{	$wordSize = strlen($word);
	if(substr($string,0,$wordSize) == $word)
	{	$args = substr($string,$wordSize);
		$args = explode($separator,$args);
		array_unshift($args,count($args));
		return $args;
	}	return array(0);
}

global $render_cache;
function noRenderCache(){global $nodesigncache;$nodesigncache=1;}
function setRenderCache($design,$content)
{	global $norendercache,$seedPath,$redis;
	if(!$norendercache)
	{	//print '<br>save render cache for <b>'.$design.'</b>';
		$redis->hset(redisPrefix.':designCache:'.$seedPath,$design,$content);
	}
	$norendercache=0;
}

function getRenderCache($design)
{	global $design_cache,$seedPath,$redis;
	if(!isset($design_cache))
	{	$design_cache = $redis->hgetall(redisPrefix.':designCache:'.$seedPath);
	}

	if(isset($design_cache[$design]))
	{	//print '<br>load '.$design.' from render cache';
		return $design_cache[$design];
	}

	return false;
}

global $design_cache;
function noDesignCache(){global $nodesigncache;$nodesigncache=1;}
function setDesignCache($design,$content)
{	global $nodesigncache,$seedPath,$designPath,$redis;
	if(!$nodesigncache)
	{	//print '<br>save cache for <b>'.$designPath.'/'.$design.'</b>';
		$redis->hset(redisPrefix.':designCache:'.$seedPath,$designPath.'/'.$design,$content);
	}
	$nodesigncache=0;
}

function getDesignCache($design)
{	global $design_cache,$seedPath,$designPath,$redis;
	if(!isset($design_cache))
	{	//$start = microtime(true);
		$design_cache = $redis->hgetall(redisPrefix.':designCache:'.$seedPath);
		//print 'load cache of '.$seedPath.' in '.((microtime(true)-$start)*1000);
	}

	if(isset($design_cache[$designPath.'/'.$design]))
	{	//print '<br>load '.$designPath.'/'.$design.' from cache';
		return $design_cache[$designPath.'/'.$design];
	}

	return false;
}

function setRedisDesign($name,$design)
{	global $redis;
	$list = redisPrefix.':design:'.template;
	$key = $list.'/'.$name;
	$redis->sadd($list,$name);
	$redis->set($key,$design);
}

function getDesign($design)
{	if($design == '') return ''; $d = getDesignCache($design); if($d !== false) return $d;
	global $nofollow,$last_design,$need_fix_name,$redis;
	if($design == 'nofolow'){ $nofollow=1; $need_fix_name=1; return ''; }
	if($design == 'folow'){   $nofollow=0; return ''; }
	if($nofollow) { return noFollowKeyWord.$design.noFollowKeyWord; }
	global $designPath,$commonDesignPath;
//	print '<br> get design "'.$design.'", path : "'.$designPath.'", common : "'.$commonDesignPath.'"';

	// search design in the template folder, absolute path
	$path = template.'/'.$designPath.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	$tkey = redisPrefix.':design:'.template.'/'.$designPath.'/'.$design;
	$ckey = redisPrefix.':design:'.common_path.'/'.$design;
//	print '<br> search for redis key '.$ckey.' '.$tkey;
	$d = $redis->multi(Redis::PIPELINE)->get($tkey)->get($ckey)->exec();
	for($n=0;$n<2;$n++)
		if(!empty($d[$n])){ ob_start(); eval('?>'.$d[$n].'<?'); $out = ob_get_contents(); ob_end_clean(); setDesignCache($design,$out); return $out; }
//	if(isset($d[1]['design'])){ ob_start(); eval('? >'.$d[1]['design'].'< ?'); $out = ob_get_contents(); ob_end_clean(); setDesignCache($design,$out); return $out; }

	// search design in the common template folder, absolute path
	$path = template.'/'.common_path.$commonDesignPath.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common folder, absolute path
	$path = common_path.$commonDesignPath.'/'.$design.'.php'; // common folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common template folder, just file, no path
	$path = template.'/'.common_path.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common folder, just file, no path
	$path = common_path.'/'.$design.'.php'; // common folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	$separator = '|';
	$mdl = explode($separator,$design);
	if(isset($mdl[0]))
	{	$mdl = $mdl[0];
		$mdlargs = getArgs($design,$mdl.$separator,$separator);
		if($mdlargs[0] > 0)
		{	$fn = 'fn_'.$mdl;
			ob_start();
			if(function_exists($fn)) $fn($mdlargs);
			else	{	$path = module_path.'/'.$mdl.'/'.$mdl.'.php';
					if(is_file($path))
					{//	print '<b> load module '.$mdl.' </b>';
						include($path); $fn($mdlargs);
					}// else { print '<br>module not found or invalid : <b>'.$mdl.'</b><br>args : '; print_r($mdlargs); }
				}
			$out = ob_get_contents(); ob_end_clean();
			setDesignCache($design,$out); return $out;
		}
	}

	//print '<br> design '.$design.' not found !';
	return '';
}

/*function isUserPrivilege($prv)
{ return (isset($_SESSION['user']) && isset($_SESSION['user'][$prv]) && $_SESSION['user'][$prv]);
}*/

?>